package com.ningdatech.pmapi.sys.controller;

import com.ningdatech.pmapi.projectlib.enumeration.InstTypeEnum;
import com.ningdatech.pmapi.sys.manage.ProcessStatisticsManage;
import com.ningdatech.pmapi.sys.model.vo.ProcessDetailStatVO;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.concurrent.TimeUnit;

/**
 * <p>
 * ProcessStatisticsController
 * </p>
 *
 * @author WendyYang
 * @since 2023/7/31
 **/
@Validated
@RestController
@RequestMapping("/api/v1/process/statistics")
@AllArgsConstructor
public class ProcessStatisticsController {

    private final ProcessStatisticsManage processStatisticsManage;

    @GetMapping("detailByInstType")
    public ProcessDetailStatVO processDetailStat(@RequestParam(required = false, defaultValue = "DAYS") TimeUnit unit,
                                                 @Valid @NotNull(message = "流程类型不能为空") InstTypeEnum instType) {
        return processStatisticsManage.processDetailStat(unit, instType);
    }

}
